#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#include <pv_types.h>

void _pv_flush(struct pv_engine	*pv_engine,
	      void		*v,
	      size_t		len)
{
	off_t offset = v - pv_engine->pv_map;

	if( pv_engine->pv_shmid < 0)
		return;

	if( offset >= pv_engine->pv_store_size)
		return;
	if( offset + len > pv_engine->pv_store_size)
		len = pv_engine->pv_store_size - offset;
	pv_engine->store.write(&pv_engine->store, offset, len);		
}


void _pv_lock(struct pv_engine	*pv_engine)
{
	static struct sembuf op = {0, -1, SEM_UNDO};
	if (semop(pv_engine->pv_sem, &op, 1) < 0) {
		perror("pv_lock");
	}
}


void _pv_unlock(struct pv_engine	*pv_engine)
{
	static struct sembuf op = {0, 1, SEM_UNDO};

	if (semop(pv_engine->pv_sem, &op, 1) < 0) {
		perror("pv_unlock");
	}
}
