#include <string.h>

#include <pv_types.h>

uint8_t *pv_register_uint8(pv_engine_t *pv_engine_anon, const char *varname)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	uint8_t *ret = NULL;
	int finished = 0; 

	if (is_last(pv_engine->pv_list) == -1) 
		return NULL; 
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
			
		if (is_last(pv_engine->pv_list))
			finished=1;

		if (!strcmp(varname, pv->name)) {
			ret = (uint8_t *)(pv_engine->pv_map + pv->offset);
			break; 
		}
	}

	return ret;
}


uint16_t *pv_register_uint16(pv_engine_t *pv_engine_anon, const char *varname)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	uint16_t *ret = NULL;
	int finished = 0; 

	if (is_last(pv_engine->pv_list) == -1) 
		return NULL; 
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		
		if (is_last(pv_engine->pv_list))
			finished=1;
		
		if (!strcmp(varname, pv->name)) {
			ret = (uint16_t *)(pv_engine->pv_map + pv->offset);
			break; 
		}
	}

	return ret;
}


uint32_t *pv_register_uint32(pv_engine_t *pv_engine_anon, const char *varname)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	uint32_t *ret = NULL;
	int finished = 0; 

	if (is_last(pv_engine->pv_list) == -1) 
		return NULL; 
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (!strcmp(varname, pv->name)) {
			ret = (uint32_t *)(pv_engine->pv_map + pv->offset);
			break; 
		}
	}

	return ret;
}


char *pv_register_string(pv_engine_t *pv_engine_anon, const char *varname)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	char *ret = NULL;
	int finished = 0; 

	if (is_last(pv_engine->pv_list) == -1) 
		return NULL; 
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (!strcmp(varname, pv->name)) {
			ret = (char *)(pv_engine->pv_map + pv->offset);
			break; 
		}
	}

	return ret;
}
